
;!define DEBUG_NO_FILES

;!define BINARY_DISTRIBUTION

; HM NIS Edit Wizard helper defines
!define PRODUCT_NAME "Qt"
!define PRODUCT_VERSION "4.0.0"
!define PRODUCT_PUBLISHER "KDE-Cygwin"
!define PRODUCT_WEB_SITE "http://kde-cygwin.sourceforge.net/"
!define PRODUCT_REG_KEY "Software\${PRODUCT_PUBLISHER}\${PRODUCT_NAME}"
!define PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define PRODUCT_UNINST_ROOT_KEY "HKLM"

SetCompressor /FINAL /SOLID lzma
SetDatablockOptimize on

AutoCloseWindow false
ShowInstDetails show

; MUI 1.67 compatible ------
!include "MUI.nsh"
!include "pathmanipulation.nsh"
!include "writeenvstr.nsh"
!include "win32-msvc.nsh"


; MUI Settings
!define MUI_ABORTWARNING
!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\modern-install.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\modern-uninstall.ico"

;--------------------------------
;Interface Configuration

!define MUI_HEADERIMAGE
!define MUI_HEADERIMAGE_BITMAP "modern-header.bmp"
!define MUI_WELCOMEFINISHPAGE_BITMAP "modern-wizard.bmp"

!insertmacro MUI_PAGE_WELCOME ; Welcome page
!insertmacro MUI_PAGE_LICENSE "..\..\LICENSE.GPL" ; License page
!insertmacro MUI_PAGE_COMPONENTS ; Components page
!insertmacro MUI_PAGE_DIRECTORY ; Directory page
Page Custom SetEnvPage SetEnvPageLeave
Page Custom SetCompilerPage SetCompilerPageLeave
!insertmacro MUI_PAGE_INSTFILES ; Instfiles page
!insertmacro MUI_PAGE_FINISH ; Finish page


!insertmacro MUI_UNPAGE_INSTFILES ; Uninstaller pages

; Language files
!insertmacro MUI_LANGUAGE "English"

; Reserve files
ReserveFile "setenvpage.ini"
!insertmacro MUI_RESERVEFILE_INSTALLOPTIONS

; MUI end ------

Name "${PRODUCT_NAME} ${PRODUCT_VERSION} by ${PRODUCT_PUBLISHER}"
OutFile qt-win-free-${PRODUCT_VERSION}.exe
InstallDir "c:\Qt\${PRODUCT_VERSION}"
InstallDirRegKey HKLM PRODUCT_REG_KEY "InstallPath"
ShowInstDetails show
ShowUnInstDetails show

Section "Qt library" SEC01
  SetOutPath "$INSTDIR"
  SetOverwrite ifnewer
!ifndef DEBUG_NO_FILES
  File "..\..\configure.exe"
  File "..\..\FAQ"
  File "..\..\INSTALL"
  File "..\..\LICENSE.GPL"
  File "..\..\OPENSOURCE-NOTICE.TXT"
  File "..\..\README"
  File "..\..\projects.pro"

  SetOutPath "$INSTDIR\bin"
  File "..\..\bin\findtr"
  File "..\..\bin\syncqt"
!ifdef BINARY_DISTRIBUTION
  File "..\..\bin\*.exe"
  File "..\..\bin\*.dll"
!endif

  SetOutPath "$INSTDIR\include"
  File /r "..\..\include\*"
  
  SetOutPath "$INSTDIR\mkspecs"
  File /r "..\..\mkspecs\*"
  
  SetOutPath "$INSTDIR\qmake"
  File "..\..\qmake\CHANGES"
  File /r "..\..\qmake\*.cpp"
  File /r "..\..\qmake\*.h"
  File /r "..\..\qmake\*.pri"
  File /r "..\..\qmake\*.pro"
  File /r "..\..\qmake\*.ui"
  File "..\..\qmake\Makefile*"

  SetOutPath "$INSTDIR\src"
  File /r "..\..\src\*.pri"
  File /r "..\..\src\*.pro"
  File /r "..\..\src\*.h"
  File /r /x "..\..\src\moc_*.cpp" "..\..\src\*.cpp"
  File /r "..\..\src\*.c"
  File /r "..\..\src\*.s"
  File /r /x "*_resource.rc" "..\..\src\*.rc"
  File /r "..\..\src\*.qrc"
  File /r "..\..\src\*.png"
  File /r "..\..\src\*.txt"

  SetOutPath "$INSTDIR\src\3rdparty"
  File /r "..\..\src\3rdparty\*"

  SetOutPath "$INSTDIR\tools"
  File /r "..\..\tools\*.pro"
  File /r "..\..\tools\*.pri"
  File /r /x "..\..\tools\moc_*.cpp" "..\..\tools\*.cpp"
  File /r /x "..\..\tools\*_resource.rc" "..\..\tools\*.rc"
  File /r "..\..\tools\*.h"
  File /r "..\..\tools\*.ui"
  File /r "..\..\tools\*.qrc"
  File /r "..\..\tools\*.ts"
  File /r "..\..\tools\*.qm"
  File /r "..\..\tools\*.ico"
  File /r "..\..\tools\*.png"
  File /r "..\..\tools\*.xml"
  File /r "..\..\tools\license.*"
  File /r "..\..\tools\*.conf"
  File /r "..\..\tools\*.qph"
  File /r "..\..\tools\*.txt"
  File /r "..\..\tools\*.icns"
  File /r "..\..\tools\*.table"
  File /r "..\..\tools\*.resource"

  SetOutPath "$INSTDIR\misc"
  File /r "..\..\misc\*.ini"
  File /r "..\..\misc\*.nsi"
  File /r "..\..\misc\*.nsh"
  File /r "..\..\misc\*.bmp"

  SetOutPath "$INSTDIR\lib"
  File "..\..\lib\README"
!ifdef BINARY_DISTRIBUTION
  File "..\..\lib\*.lib"
  File "..\..\lib\*.dll"
  File "..\..\lib\*.prl"
  File "..\..\lib\*.exp"
!endif
!endif
SectionEnd

Section "Documentation" SEC02
!ifndef DEBUG_NO_FILES
  SetOutPath "$INSTDIR\doc"
  File /r "..\..\doc\*"
!endif
SectionEnd

Section "Examples" SEC03
!ifndef DEBUG_NO_FILES
  SetOutPath "$INSTDIR\examples"
  File /r "..\..\examples\README.*"
  File /r "..\..\examples\*.pro"
  File /r /x "..\..\examples\moc_*.cpp" "..\..\examples\*.cpp"
  File /r "..\..\examples\*.h"
  File /r "..\..\examples\*.ui"
  File /r "..\..\examples\*.png"
  File /r "..\..\examples\*.jpg"
  File /r "..\..\examples\*.ts"
  File /r "..\..\examples\*.qm"
  File /r "..\..\examples\*.txt"
  File /r "..\..\examples\*.xml"
  File /r "..\..\examples\*.ini"
  File /r "..\..\examples\*.xbel"
  File /r "..\..\examples\*.cht"
  File /r "..\..\examples\*.ico"
  File /r "..\..\examples\*.icns"
  File /r "..\..\examples\*.rc"
  File /r "..\..\examples\*.qrc"
  File /r "..\..\examples\example*"
!endif
SectionEnd

Section "Demos" SEC05
!ifndef DEBUG_NO_FILES
  SetOutPath "$INSTDIR\demos"
  File /r "..\..\demos\README.*"
  File /r "..\..\demos\*.pro"
  File /r "..\..\demos\*.pri"
  File /r /x "..\..\demos\moc_*.cpp" "..\..\demos\*.cpp"
  File /r "..\..\demos\*.h"
  File /r "..\..\demos\*.ui"
  File /r "..\..\demos\*.doc"
  File /r "..\..\demos\*.html"
  File /r "..\..\demos\*.png"
  File /r "..\..\demos\*.jpg"
  File /r "..\..\demos\*.qrc"
!endif
SectionEnd

; Optional section (can be disabled by the user)
Section "Start Menu Shortcuts" SEC04
  DetailPrint "Creating Start menu shortcuts"
  WriteIniStr "$INSTDIR\${PRODUCT_NAME}.url" "InternetShortcut" "URL" "${PRODUCT_WEB_SITE}"
  CreateDirectory "$SMPROGRAMS\Qt by ${PRODUCT_PUBLISHER}"
  CreateShortCut "$SMPROGRAMS\Qt by ${PRODUCT_PUBLISHER}\OpenSource Notice" "$INSTDIR\OPENSOURCE-NOTICE.TXT"
  CreateShortCut "$SMPROGRAMS\Qt by ${PRODUCT_PUBLISHER}\Website.lnk" "$INSTDIR\${PRODUCT_NAME}.url"
  CreateShortCut "$SMPROGRAMS\Qt by ${PRODUCT_PUBLISHER}\Uninstall.lnk" "$INSTDIR\uninst.exe"
SectionEnd

Section -Post
  WriteUninstaller "$INSTDIR\bin\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\bin\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
SectionEnd

; Section descriptions
!insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC01} "Qt libraries."
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC02} "Qt Documentation"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC03} "Examples of using Qt"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC04} "Start menu shortcuts"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC05} "Demos of Qt4 Features"
!insertmacro MUI_FUNCTION_DESCRIPTION_END

Function .onInit

  ;Extract InstallOptions INI files
  !insertmacro MUI_INSTALLOPTIONS_EXTRACT "setenvpage.ini"
  !insertmacro MUI_INSTALLOPTIONS_EXTRACT "compilerpage.ini"
  !insertmacro SingleInstance
FunctionEnd


Function setEnvironmentVariables
    ; Remove old QTDIR from PATH
    ReadEnvStr $R0 "QTDIR"
    StrCmp $R0 "" setqtdir
    push $R0
    call RemoveFromPath

    DetailPrint "Setting up QTDIR"
    ; Set new QTDIR
    setqtdir:
    push "QTDIR"
    push "$INSTDIR"
    call WriteEnvStr
    
    DetailPrint "Adding QTDIR to PATH"
    ; Add QTDIR to PATH
    push "$INSTDIR"
    call AddToPath
FunctionEnd

Function registerDesignerUIExtension
   DetailPrint "Registering .ui files with Qt Designer"
   ; Register ui Extension
   ; back up old value of .ui
   ReadRegStr $1 HKCR ".ui" ""
   StrCmp $1 "" NoBackup
     StrCmp $1 "QDesignerFile" NoBackup
     WriteRegStr HKCR ".ui" "backup_val" $1
   NoBackup:
   WriteRegStr HKCR ".ui" "" "QDesignerFile"
   ;Check Associations
   ReadRegStr $0 HKCR "QDesignerFile" ""
   StrCmp $0 "" 0 skipAssoc
     WriteRegStr HKCR "QDesignerFile" "" "Program Options File"
     WriteRegStr HKCR "QDesignerFile\shell" "" "open"
     WriteRegStr HKCR "QDesignerFile\DefaultIcon" "" $INSTDIR\bin\designer.exe,1
 skipAssoc:
   WriteRegStr HKCR "QDesignerFile\shell\open\command" "" '$INSTDIR\bin\designer.exe "%1"'
   WriteRegStr HKCR "QDesignerFile\shell\edit" "" "Edit Qt Designer File"
   WriteRegStr HKCR "QDesignerFile\shell\edit\command" "" '$INSTDIR\bin\designer.exe "%1"'
FunctionEnd

Function SetEnvPage
   !insertmacro MUI_INSTALLOPTIONS_DISPLAY "setenvpage.ini"
FunctionEnd

Function SetEnvPageLeave
   ReadINIStr $0 "$PLUGINSDIR\setenvpage.ini" "Field 3" "State"
   StrCmp $0 "1" "" +2
      call setEnvironmentVariables
   ReadINIStr $0 "$PLUGINSDIR\setenvpage.ini" "Field 6" "State"
   StrCmp $0 "1" "" +2
      call registerDesignerUIExtension

FunctionEnd

Function SetCompilerPage
   !insertmacro MUI_INSTALLOPTIONS_DISPLAY "compilerpage.ini"
   ; Try to detect the compiler
   call getVSVersion
   pop $0
   StrCmp $0 "" not_msvc has_msvc
   has_msvc:
      StrCmp $0 "6.0" 0 +2
         WriteIniStr "$PLUGINSDIR\compilerpage.ini" "Field 2" "State" "win32-msvc"
      WriteIniStr "$PLUGINSDIR\compilerpage.ini" "Field 2" "State" "win32-msvc.net"
   not_msvc:
      WriteIniStr "$PLUGINSDIR\compilerpage.ini" "Field 2" "State" "win32-g++"
FunctionEnd

Function SetCompilerPageLeave
   ReadIniStr $0 "$PLUGINSDIR\compilerpage.ini" "Field 2" "State"
   ReadINIStr $1 "$PLUGINSDIR\setenvpage.ini" "Field 3" "State"
   StrCmp $1 "1" "" +6
      StrCmp $0 "" 0 +2 ; Need to have a compiler selected
         Abort
      push "QMAKESPEC"
      push $0
      call WriteEnvStr
   
   StrCmp $0 "win32-msvc.net" 0 +2
      call setQtAutoExpand

FunctionEnd

Function un.onUninstSuccess
  HideWindow
  MessageBox MB_ICONINFORMATION|MB_OK "$(^Name) was successfully removed from your computer."
FunctionEnd

Function un.onInit
  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "Are you sure you want to completely remove $(^Name) and all of its components?" IDYES +2
  Abort
FunctionEnd

Section Uninstall
  RMDir /r "$SMPROGRAMS\Qt by ${PRODUCT_PUBLISHER}"
  RMDir /r "$INSTDIR"

  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"
  push $INSTDIR
  call un.RemoveFromPath
  push "QTDIR"
  call un.DeleteEnvStr

  SetAutoClose false
SectionEnd