
!macro getVSVersion un
Function ${un}getVSVersion
    ReadRegStr $1 HKLM "Software\Microsoft\VisualStudio\7.0\Setup\VC" "ProductDir"
    StrCmp $1 "" +3 0
       push "7.0"
       return
    ClearErrors
    ReadRegStr $1 HKLM "Software\Microsoft\VisualStudio\7.1\Setup\VC" "ProductDir"
    StrCmp $1 "" +3 0
       push "7.1"
       return
    ClearErrors
    ReadRegStr $1 HKLM "Software\Microsoft\VisualStudio\8.0\Setup\VC" "ProductDir"
    StrCmp $1 "" +3 0
       push "8.0"
       return
    ClearErrors
    push ""
FunctionEnd
!macroend
!insertmacro getVSVersion ""
!insertmacro getVSVersion "un."

Function getVCPath
    MessageBox MB_OK "Checking 7.0"
    ReadRegStr $1 HKLM "Software\Microsoft\VisualStudio\7.0\Setup\VC" "ProductDir"
    StrCmp $1 "" +3 0
       push $1
       return
    ClearErrors
    MessageBox MB_OK "Checking 7.1"
    ReadRegStr $1 HKLM "Software\Microsoft\VisualStudio\7.1\Setup\VC" "ProductDir"
    StrCmp $1 "" +3 0
       push $1
       return
    ClearErrors
    MessageBox MB_OK "Checking 8.0"
    ReadRegStr $1 HKLM "Software\Microsoft\VisualStudio\8.0\Setup\VC" "ProductDir"
    StrCmp $1 "" +3 0
       push $1
       return
    push ""
FunctionEnd

Function getVSIDEPath
FunctionEnd

Function setQtAutoExpand
   push $0
   push $1
   call getVSVersion
   pop $0
   StrCmp $0 "7.1" 0 +4
      ReadRegStr $1 HKLM "SOFTWARE\Microsoft\VisualStudio\7.1\Setup\VS" "VS7CommonDir"
      StrCpy $0 "$1\Packages\Debugger\autoexp.dat"
      goto writeToAutoExpand
   StrCmp $0 "7.0" 0 +4
      ReadRegStr $1 HKLM "SOFTWARE\Microsoft\VisualStudio\7.0\Setup\VS" "VS7CommonDir"
      StrCpy $0 "$1\Packages\Debugger\autoexp.dat"
      goto writeToAutoExpand
   StrCmp $0 "8.0" 0 +4
      MessageBox MB_OK "No Support for autoexp.dat for Visual Studio 2005 yet"
      return
      goto writeToAutoExpand ; No support, dead code right now
   goto error
   writeToAutoExpand:
   WriteIniStr $0 "AutoExpand" "QString" "<d->data,su> len=<d->size,u>"
   WriteIniStr $0 "AutoExpand" "QCString" "<shd->data, s>"
   WriteIniStr $0 "AutoExpand" "QPoint" "x=<xp> y=<yp>"
   WriteIniStr $0 "AutoExpand" "QRect" "x1=<x1> y1=<y1> x2=<x2> y2=<y2>"
   WriteIniStr $0 "AutoExpand" "QSize" "width=<wd> height=<ht>"
   WriteIniStr $0 "AutoExpand" "QWMatrix" "m11=<_m11> m12=<_m12> m21=<_m21> m22=<_m22> dx=<_dx> dy=<_dy>"
   WriteIniStr $0 "AutoExpand" "QVariant" "Type=<d->typ> value=<d->value>"
   WriteIniStr $0 "AutoExpand" "QValueList<*>" "Count=<sh->nodes>"
   WriteIniStr $0 "AutoExpand" "QPtrList<*>" "Count=<numNodes>"
   WriteIniStr $0 "AutoExpand" "QGuardedPtr<*>" "ptr=<priv->obj>"
   WriteIniStr $0 "AutoExpand" "QEvent" "type=<t>"
   WriteIniStr $0 "AutoExpand" "QObject" "class=<metaObj->classname,s> name=<objname,s>"
   error:
   pop $1
   pop $0
FunctionEnd

Function un.setQtAutoExpand
   push $0
   push $1
   call un.getVSVersion
   pop $0
   StrCmp $0 "7.1" 0 +4
      ReadRegStr $1 HKLM "SOFTWARE\Microsoft\VisualStudio\7.1\Setup\VS" "VS7CommonDir"
      StrCpy $0 "$1\Packages\Debugger\autoexp.dat"
      goto writeToAutoExpand
   StrCmp $0 "7.0" 0 +4
      ReadRegStr $1 HKLM "SOFTWARE\Microsoft\VisualStudio\7.0\Setup\VS" "VS7CommonDir"
      StrCpy $0 "$1\Packages\Debugger\autoexp.dat"
      goto writeToAutoExpand
   StrCmp $0 "8.0" 0 +4
      MessageBox MB_OK "No Support for autoexp.dat for Visual Studio 2005 yet"
      return
      goto writeToAutoExpand ; No support, dead code right now
   goto error
   writeToAutoExpand:
   DeleteIniStr $0 "AutoExpand" "QString"
   DeleteIniStr $0 "AutoExpand" "QCString"
   DeleteIniStr $0 "AutoExpand" "QPoint"
   DeleteIniStr $0 "AutoExpand" "QRect"
   DeleteIniStr $0 "AutoExpand" "QSize"
   DeleteIniStr $0 "AutoExpand" "QWMatrix"
   DeleteIniStr $0 "AutoExpand" "QVariant"
   DeleteIniStr $0 "AutoExpand" "QValueList<*>"
   DeleteIniStr $0 "AutoExpand" "QPtrList<*>"
   DeleteIniStr $0 "AutoExpand" "QGuardedPtr<*>"
   DeleteIniStr $0 "AutoExpand" "QEvent"
   DeleteIniStr $0 "AutoExpand" "QObject"
   error:
   pop $1
   pop $0
FunctionEnd
